import { requestConfig } from '@/utils/request';
import { history } from '@umijs/max';
import defaultSettings from '../config/defaultSettings';

const isDev = process.env.NODE_ENV === 'development';
// const loginPath = '/user/login';

/**
 * @see  https://umijs.org/zh-CN/plugins/plugin-initial-state
 * */

export async function getInitialState() {
  // const fetchUserInfo = async () => {
  //   try {
  //     const msg = await queryCurrentUser();
  //     return msg.data;
  //   } catch (error) {
  //     history.push(loginPath);
  //   }
  //   return undefined;
  // };
  // // 如果不是登录页面，执行
  // if (history.location.pathname !== loginPath) {
  //   const currentUser = await fetchUserInfo();
  //   return {
  //     fetchUserInfo,
  //     currentUser,
  //     settings: defaultSettings,
  //   };
  // }
  return {
    // fetchUserInfo,
    settings: defaultSettings,
  };
}

// ProLayout 支持的api https://procomponents.ant.design/components/layout
export const layout = ({ initialState, setInitialState }) => {
  return {
    // rightContentRender: () => <RightContent />,
    disableContentMargin: false,
    token: {
      sider: {
        // colorBgCollapsedButton: '#fff',
        // colorTextCollapsedButtonHover: 'rgba(0,0,0,0.65)',
        // colorTextCollapsedButton: 'rgba(0,0,0,0.45)',

        // colorBgMenuItemCollapsedHover: 'rgba(0,0,0,0.06)',
        // colorBgMenuItemCollapsedSelected: 'rgba(0,0,0,0.15)',
        // colorMenuItemDivider: 'rgba(255,255,255,0.15)',
        // colorBgMenuItemHover: 'rgba(0,0,0,0.06)',
        // colorBgMenuItemSelected: 'rgba(0,0,0,0.15)',
        // colorTextMenuSelected: '#fff',
        // colorTextMenu: 'rgba(255,255,255,0.75)',
        // colorTextMenuSecondary: 'rgba(255,255,255,0.65)',
        // colorTextMenuTitle: 'rgba(255,255,255,0.95)',
        // colorTextMenuActive: 'rgba(255,255,255,0.95)',
        // colorTextSubMenuSelected: '#fff',

        colorTextMenuTitle: '#fff',
        colorMenuBackground: '#001529',
        colorTextMenu: 'rgba(255,255,255,0.65)',
        colorTextSubMenuSelected: '#fff',
        colorBgMenuItemSelected: '#1890ff',
        colorBgMenuItemHover: 'transparent',
        colorTextMenuHover: '#fff',
        colorTextMenuSelected: '#fff',
        colorTextMenuActive: 'rgba(255,255,255,0.65)',
      },
    },
    // waterMarkProps: {
    //   content: initialState?.currentUser?.name,
    // },
    // footerRender: () => <Footer />,
    onPageChange: () => {
      const { location } = history;

      // 如果没有登录，重定向到 login
      // if (!initialState?.currentUser && location.pathname !== loginPath) {
      //   history.push(loginPath);
      // }
    },
    // links: isDev
    //   ? [
    //       <Link key="openapi" to="/umi/plugin/openapi" target="_blank">
    //         <LinkOutlined />
    //         <span>OpenAPI 文档</span>
    //       </Link>,
    //     ]
    //   : [],
    menuHeaderRender: undefined,
    // 自定义 403 页面
    // unAccessible: <div>unAccessible</div>,
    // 增加一个 loading 的状态
    childrenRender: (children, props) => {
      // if (initialState?.loading) return <PageLoading />;
      return <>{children}</>;
    },

    ...initialState?.settings,
  };
};

export const request = requestConfig;
